Subject: bug#13708: 24.3.50; icomplete, ido, iswitchb: Replace C-s, C-r with C-. and C-,

From: Juri Linkov <[email-masked]>
Date: Thu, 14 Feb 2013 11:19:17 +0200

>>> How exactly the default bindings for C-s and C-r are supposed to be used
>>> in ido-mode?
>>
>> I don't know.  Just not use C-s and C-r at all.
>
> What if the user tries to use them? By reflex, or out of
> exploratory interest.
>
> I tried removing the overridded keybindings like you suggested, but C-s
> still doesn't really work after that, the interface is half-ido,
> half-isearch. That's bad.

When I tried removing the overridden keybindings from ido-mode
to use the standard isearch keybindings C-s and C-r,
I see that they are working fine in ido-mode.

But they are less useful in ido-mode, because to start isearch
from a certain place, you can't move point to that place,
because point movement keys are overridden too: C-a, C-e,
left and right arrows all use non-standard keybindings.

> So, I'm against removing them.

I agree.  It's impossible to bring icomplete and ido
closer to each other in keybindings because their keybindings
are already incompatibly different.  For instance, in ido-mode:

C-j - selects a partial input
C-m - selects a complete candidate

But in icomplete they have the opposite meaning:

C-j - selects a complete candidate
C-m - selects a partial input

So it would be better to leave ido/iswitchb keybindings intact.

Regarding `C-.' and `C-,' for icomplete-mode, I think that
even though they are non-standard, unavailable on ttys and
have unintuitive layouts on some keyboards, at least they have
one advantage to override none of standard default keybindings.